function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["width", "height", "borderRadius", "style", "children", "onChange", "timeBetweenScansMillis"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useEffect, useImperativeHandle, useRef } from 'react';
import { BrowserMultiFormatReader, NotFoundException } from '@zxing/library';
import "./index.less";
/**
 * 二维码条形码扫描组件
 */
var PisellScan = /*#__PURE__*/forwardRef(function (props, ref) {
  var width = props.width,
    height = props.height,
    borderRadius = props.borderRadius,
    style = props.style,
    children = props.children,
    onChange = props.onChange,
    _props$timeBetweenSca = props.timeBetweenScansMillis,
    timeBetweenScansMillis = _props$timeBetweenSca === void 0 ? 500 : _props$timeBetweenSca,
    others = _objectWithoutProperties(props, _excluded);
  var videoRef = useRef(null);
  var codeReaderRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      codeReader: codeReaderRef.current
    };
  });
  useEffect(function () {
    var codeReader = new BrowserMultiFormatReader(undefined, timeBetweenScansMillis);
    // 将 codeReader 实例保存到 ref 对象中
    codeReaderRef.current = codeReader;
    var selectedDeviceId;
    codeReaderRef.current.listVideoInputDevices().then(function (videoInputDevices) {
      // 选择第一个视频输入设备
      selectedDeviceId = videoInputDevices[0].deviceId;

      // 使用所选的视频设备和 videoRef 中的视频元素进行解码
      codeReader.decodeFromVideoDevice(null, videoRef.current, function (result, err) {
        // 如果解码成功，调用 onChange 回调并传递解码结果的文本
        if (result) {
          onChange === null || onChange === void 0 || onChange(result.getText());
        }
        // 如果解码出错且错误不是 NotFoundException，则输出错误到控制台
        if (err && !(err instanceof NotFoundException)) {
          console.error(err);
        }
      });
      // codeReader.reset();
    }).catch(function (err) {
      console.error(err);
    });
    return function () {
      // 重置 codeReader，停止解码和释放资源
      codeReaderRef.current.reset();
    };
  }, []);
  return /*#__PURE__*/React.createElement("div", {
    className: "pisell-scan-wrap",
    style: _objectSpread({
      width: width,
      height: height,
      borderRadius: borderRadius
    }, style)
  }, /*#__PURE__*/React.createElement("video", _extends({}, others, {
    ref: videoRef,
    style: _objectSpread({
      width: width,
      height: height,
      borderRadius: borderRadius,
      background: '#000'
    }, style)
  })), /*#__PURE__*/React.createElement("div", {
    className: "pisell-scan-action"
  }, children));
});
export default PisellScan;